<?php   
namespace Concrete\Package\OunziwVimeoLatestVideo\Block\VimeoLatestVideo;
use \Concrete\Core\Block\BlockController;

defined('C5_EXECUTE') or die(_("Access Denied."));

class Controller extends BlockController {

    protected $btTable = 'btVimeoLatestVideo';
    protected $btInterfaceWidth = 300;
    protected $btInterfaceHeight = 300;
    protected $btCacheBlockRecord = true;
    protected $btCacheBlockOutput = true;
    protected $btCacheBlockOutputOnPost = true;
    protected $btCacheBlockOutputForRegisteredUsers = false;
    protected $btCacheBlockOutputLifetime = 3600; // seconds = an hour

    public function getBlockTypeDescription()
    {
        return t("Displays your latest video on Vimeo.");
    }

    public function getBlockTypeName()
    {
        return t("Vimeo Latest Video");
    }

    public function view()
    {
        try {
            $feedurl = 'https://vimeo.com/' . $this->username . '/videos/rss';
            $channel = simplexml_load_file($feedurl);
            // latest video: $channel->channel->item[0]
            // the link: $channel->channel->item[0]->link
            $video_url_raw = $channel->channel->item[0]->link;
            // link -> embed link
            $video_url = str_replace('http://vimeo.com/','https://player.vimeo.com/video/',$video_url_raw);
            $video_url = str_replace('https://vimeo.com/','https://player.vimeo.com/video/',$video_url);

        } catch (\Exception $e) {
            \Log::addEntry(t('Failed to Get Vimeo Video Feed: ') . $feedurl . $e->getMessage(),'exceptions');
        }
        $this->set('video_url', $video_url);
        $this->set('defaulturl', $this->defaulturl);


    }

    public function save($data)
    {
        
        $args['username'] = isset($data['username']) ? trim($data['username']) : '';
        $args['defaulturl'] = isset($data['defaulturl']) ? trim($data['defaulturl']) : '';
        parent::save($args);

    }

}